﻿Public Class clsArrayOneDimensional

    Public Sub Main()


        '****************************************************************************************
        '
        ' Purpose: Creates one dimensional array
        '
        ' Syntax: 	arrayname(upperbound) As type
        '
        ' Parameter1: upperbound - specifies number of elements in array
        ' Arrays are zero based so there is one more element 
        '  than the upperbound specifies
        '
        ' Result: array - contains a set of elements
        '
        ' Syntax2: 	arrayname() As type
        ' ReDim [Preserve] arrayname(upperbound) 
        '
        ' Parameter1: Preserve - optional - specifies that existing data 
        ' in array is to be kept
        '
        ' Parameter2: upperbound - specifies number of elements in array
        ' Arrays are zero based so there is one more element
        '  than the upperbound specifies
        '
        ' Result: array - initial array is set to nothing and then
        ' the ReDim is used to specify size.
        '
        ' Quick Example: Dim aryIntegers(9) as Integer
        ' Dim aryStrings() As String 'size not specified so ReDim is needed
        ' Dim aryObjects(2) As myBook 'array of book objects
        '
        '****************************************************************************************
        ' This example is from http://idealprogrammer.com

        '****************************************************************************************
        Console.WriteLine("Example #1: Dim aryIntegers(9) as Integer")
        '****************************************************************************************

        Dim aryIntegers(9) As Integer

        Dim intCtr As Integer = 0

        'assign values to each element of array
        For intCtr = 0 To 9
            aryIntegers(intCtr) = intCtr
        Next

        ' find average value of elements in array
        Dim intAvg As Integer = 0
        Dim intElement As Integer = 0
        Dim intSum As Integer = 0
        Dim intCount As Integer = 0

        For Each intElement In aryIntegers
            intSum = intElement + intSum
            intCount = intCount + 1
        Next

        intAvg = intSum / intCount





        Console.WriteLine(intAvg.ToString()) ' Returns 4


        'write blank line to make output easier to read
        Console.WriteLine()

        '****************************************************************************************
        Console.WriteLine("Example #2: 	Dim aryStrings() As String - size is not specified at first")
        '****************************************************************************************

        Dim aryStrings() As String

        'do something like read a file to determine length of table

        ReDim aryStrings(2)

        'assign values to elements

        aryStrings(0) = "First"
        aryStrings(1) = "Second"
        aryStrings(2) = "Third"

        ' you decide you want to add another element

        ReDim Preserve aryStrings(3)

        aryStrings(3) = "Forth"

        For Each strElement As String In aryStrings
            Console.WriteLine(strElement) ' Returns the array one element at a time
        Next

        'write blank line to make output easier to read
        Console.WriteLine()

        '****************************************************************************************
        Console.WriteLine("Example #3: 	Dim aryObject() As myBook - array of class objects")
        '****************************************************************************************

        Dim aryObjects(2) As myBook


        'assign values to elements
        Dim oBook1 As New myBook
        oBook1.Author = "Plato"
        oBook1.Title = "Republic"
        aryObjects(0) = oBook1

        Dim oBook2 As New myBook
        oBook2.Author = "Aristotle"
        oBook2.Title = "Ethics"
        aryObjects(1) = oBook2

        Dim oBook3 As New myBook
        oBook3.Author = "Locke"
        oBook3.Title = "Essay Concerning Human Understanding"
        aryObjects(2) = oBook3



        For Each objElement As myBook In aryObjects
            Console.WriteLine(String.Format("{0} - {1}", objElement.Author, objElement.Title)) ' Returns the array one element at a time
        Next


        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub

End Class

Friend Class myBook

    Private _author As String
    Public Property Author() As String
        Get
            Return _author
        End Get
        Set(ByVal value As String)
            _author = value
        End Set
    End Property


    Private _title As String
    Public Property Title() As String
        Get
            Return _title
        End Get
        Set(ByVal value As String)
            _title = value
        End Set
    End Property


End Class

