﻿Imports System.Math
Public Class clsCeiling

    Public Sub Main()


        '********************************************************************************
        ' Purpose: takes a decimal or double number and returns a value 
        ' that represents the next equal or higher whole number.  
        ' Although the result is a whole number, it is returned as a
        ' the same data type that was passed in.  Math.Floor is different 
        ' in that it rounds down to the next whole number that is equal 
        ' or less than the number that is given.
        ' 
        ' Syntax: 	Ceiling(decimalnumber)
        '
        ' Parameter1: decimalnumber - decimal number
        '
        ' Result: decimal - closest whole number equal or higher
        '
        ' Syntax2: 	Ceiling(doublenumber)
        '
        ' Parameter1: doublenumber - double  precision floating point number
        '
        ' Result: double precision floating point number - closest whole number equal or higher
        '
        ' Quick Example: Ceiling(1.9) ' Returns 2
        '  
        '********************************************************************************
        ' This example is from http://idealprogrammer.com

        Console.WriteLine("Example #1: 	Ceiling(1.32) - rounds up to closest whole number")
        Dim decNumber1 As Decimal = 1.32D
        Console.WriteLine(Ceiling(decNumber1)) ' Returns 2

        'write blank line to make output easier to read
        Console.WriteLine()

        Console.WriteLine("Example #2: 	Ceiling(1.9) - rounds up to closest whole number")
        Dim douNumber2 As Double = 1.9
        Console.WriteLine(Ceiling(douNumber2)) ' Returns 2
        'write blank line to make output easier to read
        Console.WriteLine()

        Console.WriteLine("Example #3: Ceiling(-1.32) - rounds up to closest whole number")

        Dim decNumber3 As Decimal = -1.32D

        Console.WriteLine(Ceiling(decNumber3)) ' Returns -1

        Console.WriteLine("Example #4: 	Floor(1.32) - rounds down to closest whole number")
        Dim decNumber4 As Decimal = 1.32D
        Console.WriteLine(Floor(decNumber4)) ' Returns 1

        'write blank line to make output easier to read
        Console.WriteLine()

        Console.WriteLine("Example #5: 	Floor(1.9) - rounds down to closest whole number")
        Dim douNumber5 As Double = 1.9
        Console.WriteLine(Floor(douNumber5)) ' Returns 2
        'write blank line to make output easier to read
        Console.WriteLine()

        Console.WriteLine("Example #6: 	Floor(-1.32) - rounds down to closest whole number")

        Dim decNumber6 As Decimal = -1.32D

        Console.WriteLine(Floor(decNumber3)) ' Returns -2

        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub

End Class

