﻿Imports System.Math
Public Class clsMax

    Public Sub Main()


        '********************************************************************************
        ' Purpose: Returns the Max value of the two parameters that were passed in.
        ' 
        ' 
        ' Syntax: 	Max(byte,byte)
        ' Max(decimal, decimal)
        ' Max(double, double)
        ' Max(int16, int16)
        ' Max(int32, int32)
        ' Max(int64, int64)
        ' Max(sbyte, sbyte)
        ' Max(single, single)
        ' Max(UInt16, UInt16)
        ' Max(UInt32, UInt32)
        ' Max(UInt64, UInt64)
        '  
        ' Parameter1: expression - 1. byte - returns byte that is maximum of two inputs
        ' 2. decimal - returns decimal number that is maximum of two inputs
        ' 3. double - returns double-percision floating point number that is maximum of two inputs 
        ' 4. int16 - returns 16-bit integer that is maximum of two inputs 
        ' 5. int32 - returns 32-bit integer that is maximum of two inputs 
        ' 6. int64 - returns 64-bit integer that is maximum of two inputs 
        ' 7. sbyte - returns 8-bit signed integer that is maximum of two inputs 
        ' 8. single - returns single-percision floating point number that is maximum of two inputs
        ' 9. UInt16 - returns unsigned 16-bit integer that is maximum of two inputs 
        ' 10. UInt32 - returns unsigned 32-bit integer that is maximum of two inputs 
        ' 11. UInt64 - returns unsigned 64-bit integer that is maximum of two inputs 
        '
        ' Result: Depends on input - 1. byte - when input is byte 
        ' 2. decimal - when input is decimal
        ' 3. double - returns double-percision floating point number 
        ' 4. int16 - returns 16-bit integer 
        ' 5. int32 - returns 32-bit integer 
        ' 6. int64 - returns 64-bit integer 
        ' 7. sbyte - returns 8-bit signed integer 
        ' 8. single - returns single-percision floating point number
        ' 9. UInt16 - returns unsigned 16-bit integer  
        ' 10. UInt32 - returns unsigned 32-bit integer
        ' 11. UInt64 - returns unsigned 64-bit integer 
        '
        ' Quick Example: Max(1.33, 1.34)) ' Returns 1.34 as decimal
        ' 
        '********************************************************************************
        ' This example is from http://idealprogrammer.com

        Console.WriteLine("Example #1: 	Max(decimal,decimal)")
        Dim decNumber1 As Decimal = 1.33
        Dim decNumber2 As Decimal = 1.34

        Console.WriteLine(Max(decNumber1, decNumber2)) ' Returns 1.34 as decimal

        'write blank line to make output easier to read
        Console.WriteLine()

        
        Console.WriteLine("Example #2: 	Max(douNumber1,douNumber2)")
        Dim douNumber1 As Double = -3.4
        Dim douNumber2 As Double = -2.4

        Console.WriteLine(Max(douNumber1, douNumber2)) ' Returns -2.4 as double
        'write blank line to make output easier to read
        Console.WriteLine()

        Console.WriteLine("Example #3: 	Max(byte,byte)")

        Dim byteNumber1 As Integer = 5
        Dim byteNumber2 As Integer = 6


        Console.WriteLine(Max(byteNumber1, byteNumber2)) ' Returns 6 as byte

        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub

End Class

