﻿Imports System.Text
Imports System

Public Class clsStringBuilder

    Public Sub Main()

        '****************************************************************************************
        ' Example #1: StringBuilder Append(string) - most common way stringbuilder is used
        ' Adds the specified string or string representation of the specified value to the end 
        ' of the string
        '****************************************************************************************

        Console.WriteLine("Example #1: Simple StringBuilder Append(string) ")
        Dim sb As New StringBuilder
        sb.Append("First Line")
        sb.Append(vbCrLf)
        sb.Append("Second Line")

        Console.WriteLine(sb.ToString())

        'write blank line to make output easier to read
        Console.WriteLine()

        'Append(string, startIndex, count)
        '****************************************************************************************
        ' Example #2: StringBuilder Append(string, startIndex, count) 
        ' Adds a substring of the specified string, starting with the specified
        ' position and having the specified length, to the end of the string
        '****************************************************************************************

        Console.WriteLine("Example #2: StringBuilder Append(string, startIndex, count)")
        Dim sb2 As New StringBuilder
        sb2.Append("The dog and cat ")
        sb2.Append("love to fight and play", 0, 13) 'take love to fight and add to end of prev string
        Console.WriteLine(sb2.ToString())

        'write blank line to make output easier to read
        Console.WriteLine()

        'Insert(index, string[, count])
        '****************************************************************************************
        ' Example #3: StringBuilder Insert(index, string[, count]) 
        ' Inserts the specified string or a string representation of the specified
        ' value at the specified position in the string the specified number of 
        ' times. If the count is ommitted, a single copy of the string is inserted.
        '****************************************************************************************

        Console.WriteLine("Example #3: Insert(index, string[, count])")
        Dim sb3 As New StringBuilder

        sb3.Append("This is the initial sentence")
        sb3.Insert(20, "and modified ", 2)
        Console.WriteLine(sb3.ToString())

        'write blank line to make output easier to read
        Console.WriteLine()

        'Remove(startIndex,count)
        '****************************************************************************************
        ' Example #4: StringBuilder Remove(startIndex,count) 
        ' Removes the specified number of characters from the string starting at
        ' the specified position
        '****************************************************************************************

        Console.WriteLine("Example #4: StringBuilder Remove(startIndex,count)")
        Dim sb4 As New StringBuilder

        sb4.Append("This is the initial sentence")
        sb4.Remove(20, 8)
        Console.WriteLine(sb4.ToString())

        'write blank line to make output easier to read
        Console.WriteLine()

        'Replace(oldString,newString [,startIndex][,count])
        '****************************************************************************************
        ' Example #5: StringBuilder Replace(oldString,newString [,startIndex][,count])
        ' Replaces all occurences of the old string with the new string starting
        ' at the specified position and continuing for the specified number of characters.
        ' If you omit startIndex, it starts at beginning
        ' If you omit count, it does entire string
        '****************************************************************************************

        Console.WriteLine("Example #5: StringBuilder Replace(oldString,newString [,startIndex][,count])")
        Dim sb5 As New StringBuilder

        sb5.Append("This is the initial sentence")
        sb5.Replace("initial", "new")
        Console.WriteLine(sb5.ToString())

        'write blank line to make output easier to read
        Console.WriteLine()







        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub


End Class
