﻿Option Compare Text
Public Class clsFilter

    Public Sub Main()


        '****************************************************************************************
        ' Purpose: Returns a zero-based array containing a subset of a String array based on
        ' specified filter criteria.
        '
        ' Syntax: 	Filter (Source As String(), Match As String, Include As Boolean, _
        ' Compare As CompareMethod) As String()
        '
        ' Source - Required - one-dimensional string array to be searched
        ' Match - required - string to search for
        ' Include - optional - Boolean value indicating whether to return substrings that 
        ' include or exclude Match.
        ' Compare - optional - numeric value indicating compare method - CompareMethod.Binary
        ' or CompareMethod.Text
        '****************************************************************************************

        Console.WriteLine("Example #1: 	Filter(Source, Match, Include,Compare) As String")
        Dim myStrings(3) As String
        myStrings(0) = "This"
        myStrings(1) = "is"
        myStrings(2) = "my"
        myStrings(3) = "string"

        Dim FilteredStrings() As String
        FilteredStrings = Filter(myStrings, "is", True, CompareMethod.Text)

        For Each myItem As String In FilteredStrings
            Console.WriteLine(myItem) ' Returns ["This", "Is"].
        Next



        'write blank line to make output easier to read
        Console.WriteLine()



        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub


End Class
