﻿Public Class clsFormatCurrency

    Public Sub Main()


        '****************************************************************************************
        ' Syntax: 	FormatCurrency (Expression As Object, _
        ' NumDigitsAfterDecimal As Integer, _
        ' IncludeLeadingDigit As TriState, _
        ' UseParensForNegativeNumbers As TriState, _
        ' GroupDigits As TriState _
        ' ) As String
        ' 
        ' Expression - Required - Expression to be formatted
        ' NumDigitsAfterDecimal - Optional - Numeric value indicating how many places are displayed
        ' to the right of the decimal. Default value is –1, which indicates that the computer's 
        ' regional settings are used.
        ' IncludeLeadingDigit - Optional. TriState enumeration that indicates whether or not a 
        ' leading zero is displayed for fractional values. 
        ' UseParensForNegativeNumbers - Optional. TriState enumeration that indicates whether 
        ' or not to place negative values within parentheses. 
        ' GroupDigits - Optional. TriState enumeration that indicates whether or not numbers are
        ' grouped using the group delimiter specified in the computer's regional settings. 
       
        '****************************************************************************************

        Console.WriteLine("Example #1: 	FormatCurrency (Expression As Object," & _
        " NumDigitsAfterDecimal As Integer," & _
        " IncludeLeadingDigit As TriState," & _
         " UseParensForNegativeNumbers As TriState," & _
        " GroupDigits As TriState " & _
         " ) As String ")
        Dim dblNumber As Double = -5432.43

        ' Returns "($5,432.43)".
        Console.WriteLine(FormatCurrency(dblNumber, , , TriState.True, TriState.True))


        'write blank line to make output easier to read
        Console.WriteLine()



        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub


End Class
