﻿Public Class clsFormatPercent

    Public Sub Main()


        '****************************************************************************************
        ' Syntax: 	FormatPercent (Expression As Object, _
        ' NumDigitsAfterDecimal As Integer, _
        ' IncludeLeadingDigit As TriState, _
        ' UseParensForNegativeNumbers As TriState, _
        ' GroupDigits As TriState _
        ' ) As String
        '
        ' Returns an expression formatted as a percentage (that is, multiplied by 100) with 
        ' a trailing % character.
        ' 
        ' Expression - Required - Expression to be formatted
        ' NumDigitsAfterDecimal - Optional - Numeric value indicating how many places are displayed
        ' to the right of the decimal. Default value is –1, which indicates that the computer's 
        ' regional settings are used.
        ' IncludeLeadingDigit - Optional. TriState enumeration that indicates whether or not a 
        ' leading zero is displayed for fractional values. 
        ' UseParensForNegativeNumbers - Optional. TriState enumeration that indicates whether 
        ' or not to place negative values within parentheses. 
        ' GroupDigits - Optional. TriState enumeration that indicates whether or not numbers are
        ' grouped using the group delimiter specified in the computer's regional settings. 
        '****************************************************************************************

        Console.WriteLine("Example #1: 	FormatPercent (Expression As Object," & _
        " NumDigitsAfterDecimal As Integer," & _
        " IncludeLeadingDigit As TriState," & _
         " UseParensForNegativeNumbers As TriState," & _
        " GroupDigits As TriState " & _
         " ) As String ")
        Dim dblNumber As Double = -5432.43

        ' Returns "(543,243.000)".
        Console.WriteLine(FormatPercent(dblNumber, 3, , TriState.True, TriState.True))


        'write blank line to make output easier to read
        Console.WriteLine()



        'Prevent console from closing before you press enter
        Console.ReadLine()

    End Sub


End Class
